
--         -----------------------------------------------------------------------
--        |  TinyMeleeStats by Alwan (Nethersturm EU)                 |
--        |  based on TinyMeleeStats by Sideshow (Draenor EU)   |
--         -----------------------------------------------------------------------

TinyMeleeStats = {};
TinyMeleeStats.Size = 10;
TinyMeleeStats.Style = 1;
TinyMeleeStats.Action = true;

local tmsframe = CreateFrame("Frame","tmsframe",UIParent)
tmsframe:SetWidth(100);
tmsframe:SetHeight(15);
tmsframe:SetMovable(1);
tmsframe:EnableMouse(1);
tmsframe:EnableMouseWheel(1);
tmsframe:SetPoint("CENTER", UIParent, "CENTER", -100, -100);
tmsframe:SetFrameStrata("HIGH");



tmsframe:RegisterEvent("PLAYER_ENTERING_WORLD");
tmsframe:RegisterEvent("VARIABLES_LOADED");
tmsframe:RegisterEvent("UNIT_ATTACK_POWER");
tmsframe:RegisterEvent("UNIT_ATTACK_SPEED");
tmsframe:RegisterEvent("UNIT_AURA");
tmsframe:RegisterEvent("UPDATE_SHAPESHIFT_FORMS");
tmsframe:RegisterEvent("UNIT_INVENTORY_CHANGED");
tmsframe:RegisterEvent("UNIT_LEVEL");



tmsframe:SetScript("OnEvent", function() TMS_OnEvent(event, arg1) end)
tmsframe:SetScript("OnUpdate", function() TMS_OnEvent(event, arg1) end)
tmsframe:SetScript("OnMouseDown", function() tmsframe:StartMoving() end);
tmsframe:SetScript("OnMouseUp", function() tmsframe:StopMovingOrSizing() end);
tmsframe:SetScript("OnDragStop", function() tmsframe:StopMovingOrSizing() end);
tmsframe:SetScript("OnMouseWheel", function() changestyle(arg1) end);
 


local tmsstr = tmsframe:CreateFontString();
tmsstr:SetFontObject(GameFontNormal);
tmsstr:SetPoint("CENTER", tmsframe);
tmsstr:SetJustifyH("CENTER");
tmsstr:SetJustifyV("MIDDLE");



function TMS_OnEvent()
	if (event == "VARIABLES_LOADED") then
		if (TinyMeleeStats.Size == nil) then
			TinyMeleeStats.Size = 12;
		end
		if (TinyMeleeStats.Style == nil) then
			TinyMeleeStats.Style = 1;
		end
		tmsstr:SetFont(font, TinyMeleeStats.Size, "OUTLINE");
  	end
  	stats();
end



function stats()
	if ((event == "UNIT_ATTACK_POWER") or (event == "UNIT_ATTACK_SPEED") or (event == "UNIT_STATS") or (TinyMeleeStats.Action == true)) then
		if (TinyMeleeStats.Style == 1) then
			mainSpeed, offSpeed = UnitAttackSpeed("player");
			base, buff, debuff = UnitAttackPower("player");
			pow = base + buff + debuff;
			tmsstr:SetText("|c00ffef00"..pow.."|r |c00ff00ff"..string.format("%.2f", GetCritChance("player")).."|r |c001E90FF"..string.format("%.2f", mainSpeed).." "..string.format("%.2f", offSpeed).."|r");
			TinyMeleeStats.Action = false;
		elseif (TinyMeleeStats.Style == 2) then
			base, buff, debuff = UnitAttackPower("player");
			pow = base + buff + debuff;
			tmsstr:SetText("|c00ffef00"..pow.."|r");
		elseif (TinyMeleeStats.Style == 3) then
			base, buff, debuff = UnitAttackPower("player");
			pow = base + buff + debuff;
			tmsstr:SetText("|c00ffef00"..pow.."|r |c00ff00ff"..string.format("%.2f", GetCritChance("player")).."|r");
			TinyMeleeStats.Action = false;
		elseif (TinyMeleeStats.Style == 4) then
			tmsstr:SetText("|c00ff00ff"..string.format("%.2f", GetCritChance("player")).."|r");
			TinyMeleeStats.Action = false;
		elseif (TinyMeleeStats.Style == 5) then
			mainSpeed, offSpeed = UnitAttackSpeed("player");
			tmsstr:SetText("|c001E90FF"..string.format("%.2f", mainSpeed).." "..string.format("%.2f", offSpeed).."|r");
			TinyMeleeStats.Action = false;
		end
	end
end



function changestyle(arg1)
	if (IsShiftKeyDown()) then
		gName, gHeight, gFlags = tmsstr:GetFont()
		if (arg1 == 1) then
			tmsstr:SetFont(font, gHeight+1);
			gName, gHeight, gFlags = tmsstr:GetFont()
			TinyMeleeStats.Size = gHeight;
		else
			tmsstr:SetFont(font, gHeight-1);
			gName, gHeight, gFlags = tmsstr:GetFont()
			TinyMeleeStats.Size = gHeight;
		end
	else
		if (arg1 == 1) then
			TinyMeleeStats.Style = TinyMeleeStats.Style + 1;
			if (TinyMeleeStats.Style > 5) then
				TinyMeleeStats.Style = 5;
			end
			TinyMeleeStats.Action = true;
		else
			TinyMeleeStats.Style = TinyMeleeStats.Style - 1;
			if (TinyMeleeStats.Style < 1) then
				TinyMeleeStats.Style = 1;
			end
			TinyMeleeStats.Action = true;
		end
	end
	schrijf();
end
